VERSION 5.00
Begin VB.Form ScrollForm 
   BorderStyle     =   5  'Sizable ToolWindow
   Caption         =   "Scrolling Form"
   ClientHeight    =   1665
   ClientLeft      =   5175
   ClientTop       =   3555
   ClientWidth     =   5100
   LinkTopic       =   "ScrollForm"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1665
   ScaleWidth      =   5100
   ShowInTaskbar   =   0   'False
   Begin VB.PictureBox Picture1 
      Appearance      =   0  'Flat
      BackColor       =   &H8000000B&
      BorderStyle     =   0  'None
      CausesValidation=   0   'False
      Enabled         =   0   'False
      ForeColor       =   &H80000008&
      Height          =   255
      Left            =   4560
      ScaleHeight     =   255
      ScaleWidth      =   255
      TabIndex        =   17
      TabStop         =   0   'False
      Top             =   1560
      Width           =   255
   End
   Begin VB.VScrollBar VScroll1 
      Height          =   1455
      Left            =   4560
      TabIndex        =   7
      TabStop         =   0   'False
      Top             =   0
      Width           =   255
   End
   Begin VB.HScrollBar HScroll1 
      Height          =   255
      Left            =   0
      TabIndex        =   16
      TabStop         =   0   'False
      Top             =   3600
      Width           =   1455
   End
   Begin VB.CommandButton cmdQuit 
      Caption         =   "Quit"
      Height          =   375
      Left            =   3480
      TabIndex        =   15
      Top             =   120
      Width           =   975
   End
   Begin VB.TextBox Text1 
      Height          =   285
      Left            =   1080
      TabIndex        =   6
      Top             =   120
      Width           =   2175
   End
   Begin VB.TextBox Text2 
      Height          =   255
      Left            =   1080
      TabIndex        =   5
      Top             =   600
      Width           =   2175
   End
   Begin VB.TextBox Text3 
      Height          =   285
      Left            =   1080
      TabIndex        =   4
      Top             =   1035
      Width           =   2175
   End
   Begin VB.TextBox Text4 
      Height          =   270
      Left            =   1080
      TabIndex        =   3
      Top             =   1560
      Width           =   2175
   End
   Begin VB.TextBox Text5 
      Height          =   285
      Left            =   1080
      TabIndex        =   2
      Top             =   2040
      Width           =   2175
   End
   Begin VB.TextBox Text6 
      Height          =   315
      Left            =   1080
      TabIndex        =   1
      Top             =   2520
      Width           =   2175
   End
   Begin VB.TextBox Text7 
      Height          =   285
      Left            =   1080
      TabIndex        =   0
      Top             =   3000
      Width           =   2175
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Right Justify
      Caption         =   "First Name:"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   14
      Top             =   120
      Width           =   855
   End
   Begin VB.Label Label2 
      Alignment       =   1  'Right Justify
      Caption         =   "Last Name:"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   13
      Top             =   600
      Width           =   855
   End
   Begin VB.Label Label3 
      Alignment       =   1  'Right Justify
      Caption         =   "Address:"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   12
      Top             =   1080
      Width           =   855
   End
   Begin VB.Label Label4 
      Alignment       =   1  'Right Justify
      Caption         =   "City:"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   11
      Top             =   1560
      Width           =   855
   End
   Begin VB.Label Label5 
      Alignment       =   1  'Right Justify
      Caption         =   "State:"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   10
      Top             =   2040
      Width           =   855
   End
   Begin VB.Label Label6 
      Alignment       =   1  'Right Justify
      Caption         =   "Zip:"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   9
      Top             =   2520
      Width           =   855
   End
   Begin VB.Label Label7 
      Alignment       =   1  'Right Justify
      Caption         =   "Phone:"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   8
      Top             =   3000
      Width           =   855
   End
End
Attribute VB_Name = "ScrollForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'The height and width of all information on
'the screen if it were all shown at one time
Dim iFullFormHeigth As Integer
Dim iFullFormWidth As Integer
Dim oldvPos As Integer
Dim oldhPos As Integer

Private Sub cmdQuit_Click()
Unload Me
End Sub

Private Sub Form_Load()
GetFullSize
Form_Resize
End Sub

Private Sub GetFullSize()
Dim ctl As Control
Dim fullhtemp As Integer
Dim fullvtemp As Integer

fullhtemp = 0
fullvtemp = 0
For Each ctl In Me.Controls
        If ctl.Top + ctl.Height > fullvtemp Then fullvtemp = ctl.Top + ctl.Height
        If ctl.Left + ctl.Width > fullhtemp Then fullhtemp = ctl.Left + ctl.Width
Next
iFullFormHeigth = fullvtemp + HScroll1.Height
iFullFormWidth = fullhtemp + VScroll1.Width
End Sub

Private Sub Form_Resize()

VScroll1.Left = Me.Width - (1.45 * VScroll1.Width)
HScroll1.Top = Me.Height - (2.45 * HScroll1.Height)

Picture1.Left = VScroll1.Left
Picture1.Top = HScroll1.Top

'If the full screen is already showing,
'then disable the scrollbar
VScroll1.Enabled = (iFullFormHeigth - Me.Height) >= 0

'First, make sure we aren't minimized
If Me.ScaleHeight > HScroll1.Height And Me.Width > VScroll1.Width Then
    
    'If there is any more screen to see,
    'modify the scrollbar
    If VScroll1.Enabled Then
        With VScroll1
            .Height = Me.ScaleHeight - HScroll1.Height
            .Min = 0
            .Max = iFullFormHeigth - Me.Height
            .SmallChange = Screen.TwipsPerPixelY * 10
            .LargeChange = Me.ScaleHeight - HScroll1.Height
        End With

    'Otherwise, just resize the scrollbar for neatness
    Else: VScroll1.Height = Me.ScaleHeight - HScroll1.Height
    End If

    HScroll1.Enabled = (iFullFormWidth - Me.Width) >= 0
    If HScroll1.Enabled Then
        With HScroll1
            .Width = Me.ScaleWidth - VScroll1.Width
            .Min = 0
            .Max = iFullFormWidth - Me.Width
            .SmallChange = Screen.TwipsPerPixelX * 10
            .LargeChange = Me.ScaleWidth - VScroll1.Width
        End With

    Else: HScroll1.Width = Me.ScaleWidth - VScroll1.Width
    End If
End If
End Sub

Private Sub pScrollForm()
Dim ctl As Control

'Moves each textbox and Control if the scrollbar is clicked
For Each ctl In Me.Controls
    If Not (TypeOf ctl Is VScrollBar) And _
        Not (TypeOf ctl Is PictureBox) And _
        Not (TypeOf ctl Is HScrollBar) Then
        ctl.Top = ctl.Top + oldvPos - VScroll1.Value
        ctl.Left = ctl.Left + oldhPos - HScroll1.Value
    End If
Next

oldvPos = VScroll1.Value
oldhPos = HScroll1.Value
End Sub

Private Sub VScroll1_Change()
    Call pScrollForm
End Sub

Private Sub VScroll1_Scroll()
    Call pScrollForm
End Sub

Private Sub HScroll1_Change()
    Call pScrollForm
End Sub

Private Sub HScroll1_Scroll()
    Call pScrollForm
End Sub

